%
% a simple test program from Ivan Bratko's
% Prolog Programming for Artificial Intelligence
%

parent(pam,bob).     % pam is a parent of bob
parent(tom,bob).
parent(tom,liz).
parent(bob,ann).
parent(bob,pat).
parent(pat,jim).
parent(jane,john).

female(pam).         % pam is female
male(tom).           % tom is male
male(bob).
female(liz).
female(ann).
female(pat).
male(jim).

offspring(Y,X) :-    % Y is an offspring of X if
   parent(X,Y).      % X is a parent of Y

mother(X,Y) :-       % X is the mother of Y if
   parent(X,Y),      % X is a parent of Y and
   female(X).        % X is female

grandparent(X,Z) :-  % X is a grandparent of Z if
   parent(X,Y),      % X is a parent of Y and
   parent(Y,Z).      % Y is a parent of Z

predecessor(X,Z) :-  % X is a predecessor of Z if
   parent(X,Z).      % X is a parent of Z

predecessor(X,Z) :-  % X is a predecessor of Z if
   parent(X,Y),      % X is a parent of Y and
   predecessor(Y,Z). % Y is a predecessor of Z


