/*
 * jPrologBacktrackData.java
 *
 * Copyright(c) 2002, Particle Corp.
 */

import java.util.Hashtable;

/**
 * Represents data needed for backtracking.
 *
 * @author Alex S.
 * @version 0.0.1
 */
public class jPrologBacktrackData {

    // current rule that matched
    private jPrologList rule;

    // goal that was replaced
    private jPrologNode goal;

    // everything above this number should be wiped out during backtracking.
    private Hashtable variables;

    // number of replaced goals
    private int numGoals;

    /**
     * constructs a 'list'
     */
    public jPrologBacktrackData(jPrologList r,jPrologNode n,Hashtable vars,int goals){
        rule = r;
        goal = n;
        variables = vars;
        numGoals = goals;
    }

    /**
     * gets current node from database
     */
    public jPrologList getRule(){
        return rule;
    }

    /**
     * gets current node from database
     */
    public jPrologNode getGoal(){
        return goal;
    }

    /**
     * get variable stack
     */
    public Hashtable getVariables(){
        return variables;
    }

    /**
     * get number of replaced goals
     */
    public int getNumGoals(){
        return numGoals;
    }

}

