/*
 * jPrologRule_consult.java
 *
 * Copyright(c) 2002, Particle Corp.
 */

import java.io.*;
import java.util.*;

/**
 * jProlog rule interface
 *
 * @author Alex S.
 * @version 0.0.1
 */
public class jPrologRule_consult implements jPrologRuleInterface {

    public jPrologNode getMatcher() throws jPrologException {
        try{
            return jPrologParser.parse("consult(File).");
        }catch(IOException e){
            throw new jPrologException(e.getMessage());
        }
    }

    public boolean invoke(Hashtable vars,Hashtable database) throws jPrologException {

        jPrologNode fileNode = (jPrologNode)vars.get("File");
        vars.remove("File");      // null out the variable.
        String fileName = fileNode.getName();
        try{
            FileReader sr = new FileReader(fileName);
            jPrologLexer lexer = new jPrologLexer(sr);
            jPrologParser parser = new jPrologParser(lexer);
            Vector clauses = parser.parse();
            sr.close();
            Enumeration enum = clauses.elements();
            while(enum.hasMoreElements()){
                jPrologNode n = (jPrologNode)enum.nextElement();
                String name = n.getName() + "/" + n.getArity();
                if(n.getName().equals(":-"))   // if rule
                    name = n.getHead().getName() + "/" + n.getHead().getArity();

                Object o = database.get(name);
                Vector v;
                if(o == null){
                    database.put(name,v = new Vector());
                }else if(o instanceof Vector){
                    v = (Vector)o;
                }else{
                    database.remove(name);
                    database.put(name,v = new Vector());
                }
                v.addElement(n);
            }

            // convert all those vectors in database to linked lists
            enum = database.keys();
            while(enum.hasMoreElements()){
                String key = (String)enum.nextElement();
                Object o = database.get(key);
                if(o instanceof Vector){
                    Vector v = (Vector)o;
                    jPrologList list = null;
                    for(int i=v.size()-1;i>=0;i--)
                        list = new jPrologList(v.elementAt(i),list);
                    database.put(key,list);
                }
            }
        }catch(jPrologException e){
            throw new jPrologException("["+fileName+"] "+e.getMessage());
        }catch(IOException e){
            throw new jPrologException(e.getMessage());
        }
        return true;
    }

}

