%
% some simple 'standard' definition
%

% member relation
member(X,[X|Tail]).
member(X,[Head|Tail]) :-
   member(X,Tail).

% do list concatenation
conc([],L,L).
conc([X|L1],L2,[X|L3]) :-
   conc(L1,L2,L3).

% select X from a list
select([X|Xs],X,Xs).
select([X|Xs],Y,[X|Ys]) :-
   select(Xs,Y,Ys).

% generate permutations
perm([],[]).
perm(Xs,[X|Ys]) :-
   select(Xs,X,Xs1),
   perm(Xs1,Ys).

